function [gx,hx,ind] = modelsolve(M)

rhoa_p  =M(1,1);
rhog_p  =M(1,2);
rhor_p  =M(1,3);
teta_p  =M(1,4);
eta_p   =M(1,8);
phi_p   =M(1,9);

[ALFA,SIGAMA,BETTA,PHI,MIUG,DELTA,RSTAR,S,PSSI,B,RHOR,RHOZ,TAU,V,TETHA,ETA,RHOG,...
c,cp,h,hp,yy,yyp,q,qp,rstar,rstarp,k,kp,k1,k1p,b,bp,iv,ivp,z,zp,nx,nxp,la,lap,w,wp,u,up,r,rp,rl,rlp,s,sp,g,gp,gl,glp,...
gy,gyp,yyl,yylp,gc,gcp,cl,clp,giv,givp,ivl,ivlp,dnx,dnxp,nxl,nxlp,sr,srp,SR] = ...
encompassing_ss_est(rhog_p,rhor_p,rhoa_p,teta_p,eta_p,phi_p);

% COMPUTE ANALYTICAL DERIVATIVES, EVALUATE THEM AND SOLVE MODEL
% -------------------------------------------------------------

nfx = ...
[                              (1-DELTA)*exp(k)-1/2*PHI*exp(k)*(exp(g)*exp(kp)/exp(k)-MIUG)^2+PHI*(exp(g)*exp(kp)/exp(k)-MIUG)*exp(g)*exp(kp),                                                                                                                                           0,                                                                             -exp(g)*exp(kp)-PHI*(exp(g)*exp(kp)/exp(k)-MIUG)*exp(g)*exp(kp),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                exp(u)*exp(k),                                                                                                                                     -exp(b),                                                                                                                       exp(q)*exp(g)*exp(bp),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                           exp(rstar)*exp(s),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                     -BETTA*exp(g)^(-SIGAMA)*SIGAMA*exp(lap),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                            exp(la)*PHI*exp(g)*exp(kp)/exp(k),                                                                                                                                           0, -exp(la)*PHI*exp(g)*exp(kp)/exp(k)-BETTA*exp(g)^(-SIGAMA)*SIGAMA*exp(lap)*(exp(up)+1-DELTA+1/2*PHI*(exp(gp)^2*exp(k1p)^2/exp(kp)^2-MIUG^2)),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                         exp(z)*exp(k)^(1-ALFA)*(1-ALFA)*(exp(g)*exp(h))^ALFA,                                                                                                                                           0,                                                                                            exp(z)*exp(k)^(1-ALFA)*(exp(g)*exp(h))^ALFA*ALFA,                                                                                                                                           0,                                                                                                 exp(z)*exp(k)^(1-ALFA)*(exp(g)*exp(h))^ALFA,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                    -(1-ALFA)*exp(z)*exp(k)^(-ALFA)*ALFA*(exp(g)*exp(h))^ALFA,                                                                                                                                           0,                                                                                    (1-ALFA)*exp(z)*exp(k)^(-ALFA)*ALFA*(exp(g)*exp(h))^ALFA,                                                                                                                                           0,                                                                                         (1-ALFA)*exp(z)*exp(k)^(-ALFA)*(exp(g)*exp(h))^ALFA,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                             ALFA*exp(z)*exp(k)^(1-ALFA)*(1-ALFA)*exp(h)^(ALFA-1)*exp(g)^ALFA,                                                                                                                                           0,                                                                                   ALFA^2*exp(z)*exp(k)^(1-ALFA)*exp(h)^(ALFA-1)*exp(g)^ALFA,                                                                                                                                           0,                                                                                     ALFA*exp(z)*exp(k)^(1-ALFA)*exp(h)^(ALFA-1)*exp(g)^ALFA,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                       -exp(w)*TETHA*exp(rl),                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                   -exp(gl)*exp(yy)/exp(yyl),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                    exp(gl)*exp(yy)/exp(yyl);
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                     -exp(gl)*exp(c)/exp(cl),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                      exp(gl)*exp(c)/exp(cl);
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                   -exp(gl)*exp(iv)/exp(ivl),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                    exp(gl)*exp(iv)/exp(ivl);
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                   -exp(nxl),                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                        RHOZ,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                        RHOG,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                        RHOR,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                     exp(z)*exp(g)^ALFA*ALFA,                                                                                                                                           0,                                                                                                                          exp(z)*exp(g)^ALFA,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                      exp(g),                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0;
                                                                                                                                            0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0,                                                                                                                                           0];
 
nfxp = ...
[                                       -exp(g)*exp(kp)-PHI*(exp(g)*exp(kp)/exp(k)-MIUG)*exp(g)*exp(kp),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                 exp(q)*exp(g)*exp(bp),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                           PSSI*exp(bp)*exp(exp(bp)-B),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
  -exp(la)*PHI*exp(g)*exp(kp)/exp(k)-BETTA*exp(g)^(-SIGAMA)*exp(lap)*PHI*exp(gp)^2*exp(k1p)^2/exp(kp)^2,                                                                                                     0,                                    BETTA*exp(g)^(-SIGAMA)*exp(lap)*PHI*exp(gp)^2*exp(k1p)^2/exp(kp)^2,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                    -1,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                    -1,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                    -1,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                exp(kp),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                            -exp(yylp),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                             -exp(clp),                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                            -exp(ivlp),                                                                                                     0,                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                            -exp(nxlp),                                                                                                     0,                                                                                                     0;
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                             -exp(glp);
                                                                                                      0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                                     0,                                                                                             -exp(rlp),                                                                                                     0];
 
nfy = ...
[                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     exp(iv),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                       exp(q)*exp(g)*exp(bp),                                                                     -exp(c),                                                               exp(w)*exp(h),                                                                    -exp(iv),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                               exp(w)*exp(h),                                                               exp(u)*exp(k),                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                      exp(r),                                                                    1/exp(q),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                     -exp(r),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                           exp(rstar)*exp(s),                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,        -(exp(c)-TAU*exp(h)^V)^(-SIGAMA)*SIGAMA*exp(c)/(exp(c)-TAU*exp(h)^V), (exp(c)-TAU*exp(h)^V)^(-SIGAMA)*SIGAMA*TAU*exp(h)^V*V/(exp(c)-TAU*exp(h)^V),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                    -exp(la),                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                   -TAU*V*exp(h)^(V-1)*(V-1),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                      exp(w),                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                             -exp(la)*exp(q),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                             -exp(la)*exp(q),                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                               -exp(la)*(1+PHI*(exp(g)*exp(kp)/exp(k)-MIUG)),                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                            exp(z)*exp(k)^(1-ALFA)*(exp(g)*exp(h))^ALFA*ALFA,                                                                           0,                                                                    -exp(yy),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                    (1-ALFA)*exp(z)*exp(k)^(-ALFA)*ALFA*(exp(g)*exp(h))^ALFA,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     -exp(u),                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,            ALFA*exp(z)*exp(k)^(1-ALFA)*exp(h)^(ALFA-1)*(ALFA-1)*exp(g)^ALFA,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                               -exp(w)*(1+TETHA*(exp(rl)-1)),                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                             -exp(c)/exp(yy),                                                                           0,                                                            -exp(iv)/exp(yy),                                          1-(exp(yy)-exp(iv)-exp(c))/exp(yy),                                                                          -1,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                     -exp(gy),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                    exp(gl)*exp(yy)/exp(yyl),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                    -exp(gc),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                      exp(gl)*exp(c)/exp(cl),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                   -exp(giv),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                    exp(gl)*exp(iv)/exp(ivl),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                   -exp(dnx),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     exp(nx),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                    -exp(sr);
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                          -1,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                    -exp(k1),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     exp(yy),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                      exp(c),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     exp(iv),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                     exp(nx),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0;
                                                                            0,                                                                           0,                                                                           0,                                                                           0,                                                                      exp(r),                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0,                                                                           0];

nfyp = ...
[                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                   BETTA*exp(g)^(-SIGAMA)*exp(lap),                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                BETTA*exp(g)^(-SIGAMA)*exp(lap)*PHI*exp(gp)^2*exp(k1p)^2/exp(kp)^2, BETTA*exp(g)^(-SIGAMA)*exp(lap)*(exp(up)+1-DELTA+1/2*PHI*(exp(gp)^2*exp(k1p)^2/exp(kp)^2-MIUG^2)),                                                                                                 0,                                                           BETTA*exp(g)^(-SIGAMA)*exp(lap)*exp(up),                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                              -ETA;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0;
                                                                                                  0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0,                                                                                                 0];

[gx,hx,ind] = gx_hx_modif(nfy,nfx,nfyp,nfxp); 
